﻿using System;
using System.Threading;

namespace CyberCriminal
{
    class Driver
    {
        string[] files;
        string[] directorys;
        int filesCount;
        int directorysCount;
        string InvalidArgumentsException = "Invalid arguments.";
        string CurrentDirectory = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location);

        Storage store = new Storage();
        Target player;

        static int targets = 20;
        Target[] target = new Target[targets];
        Target[] hackedTarget;


        public Driver()
        {
            Console.WriteLine("Derpsoft Doors v 1.348");
            Console.WriteLine("Copyright joppiesaus 2013");
            Console.WriteLine();

            player = new Target(false);

            for (int i = 0; i < targets; i++)
            {
                target[i] = new Target(true, i);
            }

            command();
        }

        public void init(string path)
        {
            files = System.IO.Directory.GetFiles(path);
            System.IO.DirectoryInfo dir = new System.IO.DirectoryInfo(path);
            filesCount = dir.GetFiles().Length;

            directorys = System.IO.Directory.GetDirectories(path);
            System.IO.DirectoryInfo dirInfo = new System.IO.DirectoryInfo(path);
            directorysCount = dirInfo.GetDirectories().Length;
        }

        public void command()
        {
            bool doneSomething = false;
            string input = Console.ReadLine();
            string msg = input.ToLower();
            
            //start a file or open a directory direclty
            if (System.IO.File.Exists(input) || System.IO.Directory.Exists(input))
            {
                try
                {
                    System.Diagnostics.Process.Start(input);
                }
                catch
                {
                    Console.WriteLine("An error orcurred while starting the file.");
                }
                doneSomething = true;
                Console.WriteLine();
            }

            if (!doneSomething)
            {
                //gets the files and directorys so somebody can launch them. the Console.WriteLine(); is for the new line, (anti-derp)
                init(CurrentDirectory);
                for (int i = 0; i < filesCount; i++)
                {
                    string start = files[i].Replace(CurrentDirectory + @"\", "");
                    string start1 = start.Split('.')[0];
                    if (input == start || input == start1 || msg == start1.ToLower() || msg == start.ToLower())
                    {
                        System.Diagnostics.Process.Start(files[i]);
                        doneSomething = true;
                    }
                }

                for (int i = 0; i < directorysCount; i++)
                {
                    string start = directorys[i].Replace(CurrentDirectory + @"\", "");
                    if (input == start || input == start.ToLower())
                    {
                        System.Diagnostics.Process.Start(directorys[i]);
                        doneSomething = true;
                    }
                }
            }

            if (msg.Split(' ')[0] == "cls")
            {
                Console.Clear();
            }
            else if (msg.Split(' ')[0] == "help")
            {
                Console.Write(help());
            }
            else if (msg.Split(' ')[0] == "exit")
            {
                Environment.Exit(0);
            }
            else if (msg.Split(' ')[0] == "connection")
            {
                showIPs();
            }
            else if (msg.Split(' ')[0] == "ping")
            {
                int argument = 0;
                try
                {
                    int amountOfSpaces = msg.Split(' ').Length - 1;

                    if (amountOfSpaces >= 2)
                    {
                        try
                        {
                            argument = Convert.ToInt32(msg.Split(' ')[2]);
                        }
                        catch
                        {
                            argument = 0;
                        }
                    }

                    ping(msg.Split(' ')[1], argument);
                }
                catch
                {
                    Console.WriteLine(InvalidArgumentsException);
                }
            }
            else if (msg.Split(' ')[0] == "set")
            {
                int amountOfSpaces = msg.Split(' ').Length - 1;

                try
                {
                    if (amountOfSpaces == 1)
                    {
                        set(msg.Split(' ')[1], "");
                    }
                    else if (amountOfSpaces >= 2)
                    {
                        set(msg.Split(' ')[1], msg.Split(' ')[2]);
                    }
                    else
                    {
                        Console.WriteLine(InvalidArgumentsException);
                    }
                }
                catch
                {
                    Console.WriteLine(InvalidArgumentsException);
                }
            }
            else if (msg.Split(' ')[0] == "echo")
            {
                try
                {
                    string message = input.Replace("echo", "");
                    echo(message);
                }
                catch
                {
                    echo("");
                }
            }
            else if (msg.Split(' ')[0] == "system")
            {
                getSystem();
            }
            else if (msg.Split(' ')[0] == "color")
            {
                try
                {
                    string color = msg.Split(' ')[1];
                    setColor(color);
                }
                catch
                {
                    setColor("reset");
                }
            }
            else if (msg.Split(' ')[0] == "force")
            {
                try
                {
                    string ipAdress = msg.Split(' ')[1];
                    force(ipAdress);
                }
                catch
                {
                    Console.WriteLine(InvalidArgumentsException);
                }
            }
            else if (msg.Split(' ')[0] == "storage")
            {
                try
                {
                    if (msg.Split(' ')[1] == "remove" || msg.Split(' ')[1] == "rmv")
                    {
                        store.remove(input.Split(' ')[2]);
                    }
                    else if (msg.Split(' ')[1] == "get")
                    {
                        string display = store.get(input.Split(' ')[2]);

                        if (display != "")
                        {
                            Console.WriteLine("The field \"" + msg.Split(' ')[2] + "\" has a value of \"" + display + "\"");
                        }
                    }
                    else if (msg.Split(' ')[1] == "set")
                    {
                        string str1 = input.Split(' ')[2];
                        string str2 = input.Split(' ')[3];
                        store.store(str1, str2);
                    }
                    else
                    {
                        string str1 = input.Split(' ')[1];
                        string str2 = input.Split(' ')[2];
                        store.store(str1, str2);
                    }
                }
                catch
                {
                    Console.WriteLine(InvalidArgumentsException);
                }
            }
            else if (msg.Split(' ')[0] == "date")
            {
                date();    
            }
            else if (msg.Split(' ')[0] == "dir" || msg.Split(' ')[0] == "directory")
            {
                int amountOfSpaces = msg.Split(' ').Length - 1;

                try
                {
                    if (amountOfSpaces > 0) 
                    {
                        if (msg.Split(' ')[1] == "modify")
                        {
                            dir(CurrentDirectory, true);
                        }
                        else
                        {
                            dir(input.Split(' ')[1]);
                        }
                    }
                    else if (amountOfSpaces > 1)
                    {
                        bool mod = false;
                        if (input.Split(' ')[2] == "modify")
                        {
                            mod = true;
                        }
                        dir(input.Split(' ')[1], mod);
                    }
                    else
                    {
                        dir(CurrentDirectory);
                    }
                }
                catch
                {
                    Console.WriteLine("Invalid arguments or path that doesn't exist.");
                }
            }
            else if (msg.Split(' ')[0] == "cd")
            {
                try
                {
                    cd(input.Split(' ')[1]);
                }
                catch
                {
                    cd();
                }
            }
            else if (msg.Split(' ')[0] == "throw")
            {
                throwException(input.Replace(input.Split(' ')[0] + " ", ""));
            }
            else if (msg.Split(' ')[0] == "game")
            {
                try
                {
                    game(msg.Split(' ')[1]);
                }
                catch
                {
                    Console.WriteLine(InvalidArgumentsException);
                }
            }
            else if (!doneSomething)
            {
                Console.WriteLine("Bad command or illigal filename.");
            }

            Console.WriteLine();
            command();
        }

        string help()
        {
            string enter = System.Environment.NewLine;
            char tab = '\t';
            return enter + "HELP - shows the help" + enter + "CLS  - clears the screen" + enter + "EXIT - exits the program" + enter + "CONNECTION - shows the recent connections" +
                enter + "PING <ip> [times] - checks the connection between you and the target ip." + enter + "SET <field> - sets the specified field to a specified value." +
                 enter + tab + "Valid fields are IP, NAME, TITLE, WIDTH, HEIGHT." + enter + "ECHO - displays a specified message." + enter + "COLOR [color] - sets a specified color" +
                 ". Leave empty or type reset to reset." + enter + "FORCE <ip> - Forces and spams an IP in order to get usernames and passwords." + enter + "STORAGE [argument]" +
                 " <field> [value] - Argument SET or no argument stores a" + enter + tab + "specific field and value temporary. Argument GET will get a value of a" +
                 enter + tab + "field. Argument remove or rmv will remove a specific field and value." + enter + "SYSTEM - Shows your machine & systems specifications." + enter +
                 "DATE - displays the date and time." + enter + "DIRECTORY [path | modify] - Shows the files in a specific directory. Shortcut" + enter + tab + " dir. argument modify"
                 + " displays the time it is modified for each file." + enter + "CD [path | back] - Goes" + " to a directory or displays it." + enter + "THROW [Exception] - " +
                 " Throws an exception." + enter + "GAME <game> - Starts a game. Valid games are: fourinarow" + enter + "SECURE [-s field] <encrypt | decrypt> <password> <message>" +
                 " - Decrypts or " + enter + tab + "Encrypts a message. -s arguments makes the encrypted / " + enter + tab + "decrypted message store." + enter;
        }

        string subSet(string what, string first)
        {
            Console.WriteLine("Enter the new " + what + ":");
            string toReturn = Console.ReadLine();
            Console.WriteLine("Succesfully changed " + what + " from " + first + " to " + toReturn);
            return toReturn;
        }

        void showIPs()
        {
            Console.WriteLine();
            Console.WriteLine("Recent connections:");
            for (int i = 0; i < targets; i++)
            {
                int seed = Convert.ToInt32(target[i].ipAdress.Split('.')[0]);
                Random rand = new Random(seed + i);
                int num = rand.Next(1, 100);
                string space = "";
                if (num < 10)
                {
                    space = " ";
                }
                Console.WriteLine("IP: " + target[i].ipAdress + "  -  last reply " + num.ToString() + space + " minutes ago");
            }
        }

        void ping(string ip, int times)
        {
            int targetArray = -1;

            for (int i = 0; i < targets; i++)
            {
                if (ip == target[i].ipAdress)
                {
                    targetArray = i;
                }
            }

            if (targetArray != -1)
            {
                int total = 0;

                if (times == 0)
                {
                    total = 4;
                }
                else
                {
                    total = times;
                }

                Console.WriteLine("Pinging target host, " + target[targetArray].ipAdress);
                int average = 0;

                for (int i = 0; i < total; i++)
                {
                    Random rand = new Random();
                    Console.WriteLine("Got reply from: " + target[targetArray].ipAdress + " in " + rand.Next(0, 700).ToString() + " ms");
                    average += rand.Next(0, 700);
                    Thread.Sleep(701);
                }
                average = average / total;
                Console.WriteLine("Ping completed.");
                Console.WriteLine("Pinged " + total.ToString() + " times, with a average time of " + average.ToString() + " ms.");
                Console.WriteLine();
            }
            else
            {
                Console.WriteLine("Unknown host.");
            }
        }

        void set(string setWhat, string arg1)
        {
            if (setWhat == "ip")
            {
                player.ipAdress = subSet("IP adress", player.ipAdress);
                
            }
            else if (setWhat == "name")
            {
                player.name = subSet("name", player.name);
            }
            else if (setWhat == "password" || setWhat == "pass")
            {
                player.password = subSet("password", player.password);
            }
            else if (setWhat == "title")
            {
                Console.Title = subSet("window title", Console.Title);
            }
            else if (setWhat == "width")
            {
                setConsoleSize(arg1, false);
            }
            else if (setWhat == "height")
            {
                setConsoleSize(arg1, true);
            }
            else
            {
                Console.WriteLine("Invalid field.");
            }
        }

        void echo(string echo)
        {
            Console.WriteLine(echo + System.Environment.NewLine);
        }

        void getSystem()
        {
            Console.WriteLine();
            Console.WriteLine("Your system: ");
            Console.WriteLine("OS                " + System.Environment.OSVersion);
            Console.WriteLine("OS 64-bit         " + System.Environment.Is64BitOperatingSystem);
            Console.WriteLine("Machine name      " + System.Environment.MachineName);
            Console.WriteLine("Framework version " + System.Environment.Version);
            Console.WriteLine("Uptime in ticks   " + System.Environment.TickCount);
            Console.WriteLine("Processors        " + System.Environment.ProcessorCount);
            Console.WriteLine("Username          " + System.Environment.UserName);
            Console.WriteLine("User domain name  " + System.Environment.UserDomainName);
            Console.WriteLine("System directory  " + System.Environment.SystemDirectory);
            Console.WriteLine("Cluster size in B " + System.Environment.SystemPageSize);
            Console.WriteLine("Workingset        " + System.Environment.WorkingSet);
        }

        void setColor(string color)
        {
            if (color == "reset")
            {
                Console.ResetColor();
            }
            else if (color == "blue")
            {
                Console.ForegroundColor = ConsoleColor.Blue;
            }
            else if (color == "red")
            {
                Console.ForegroundColor = ConsoleColor.Red;
            }
            else if (color == "green")
            {
                Console.ForegroundColor = ConsoleColor.Green;
            }
            else if (color == "white")
            {
                Console.ForegroundColor = ConsoleColor.White;
            }
            else if (color == "pink")
            {
                Console.ForegroundColor = ConsoleColor.Magenta;
            }
            else if (color == "yellow")
            {
                Console.ForegroundColor = ConsoleColor.Yellow;
            }
            else if (color == "cyan")
            {
                Console.ForegroundColor = ConsoleColor.Cyan;
            }
            else
            {
                Console.WriteLine("Unknown color");
            }
        }

        void force(string ip)
        {
            int array = -1;
            string password = "";
            string username = "";

            for (int i = 0; i < targets; i++)
            {
                if (ip == target[i].ipAdress)
                {
                    array = i;
                    password = target[i].password;
                    username = target[i].name;
                }
            }

            Random rand = new Random();

            Console.WriteLine();
            Console.WriteLine("Connecting...");
            Thread.Sleep(rand.Next(500, 1000));

            if (array == -1)
            {
                Console.WriteLine("Failed to connect. Reason: Unknown host.");
            }
            else
            {
                fakeEncryptStuff(password);
                Thread.Sleep(1000);
                fakeEncryptStuff(username);
                Thread.Sleep(500);

                Console.WriteLine();
                Console.WriteLine("Username: " + username);
                Console.WriteLine("Password: " + password);
            }
        }

        void fakeEncryptStuff(string stuff, int timeOut = 750)
        {
            string encryptedPass = "";

            for (int i = 0; i < stuff.Length; i++)
            {
                encryptedPass = encryptedPass.Insert(0, ".");
            }

            Console.WriteLine(encryptedPass);
            Thread.Sleep(800);

            char[] pass = stuff.ToCharArray();

            int doAgain = 0;
            for (int i = 0; i < (stuff.Length + doAgain); i++)
            {
                //ultra random
                Random ran = new Random(Guid.NewGuid().GetHashCode());

                int num = ran.Next(0, stuff.Length);
                string dontbreak = encryptedPass.Substring(num);

                if (!dontbreak.StartsWith("."))
                {
                    doAgain++;
                }
                else
                {
                    Thread.Sleep(timeOut);
                    encryptedPass = encryptedPass.Insert(num, pass[num].ToString());
                    encryptedPass = encryptedPass.Remove(num + 1, 1);
                    Console.WriteLine(encryptedPass);
                }
            }
        }

        void date()
        {
            Console.WriteLine();
            Console.WriteLine(DateTime.Now);
        }

        void dir(string path, bool arguments = false)
        {
            init(path);
            Console.WriteLine();
            Console.WriteLine("Files and directorys in directory " + path + " :");
            Console.WriteLine("Contains " + filesCount.ToString() + " files and " + directorysCount.ToString() + " directorys.");
            Console.WriteLine();

            for (int i = 0; i < directorysCount; i++)
            {
                string mod;
                DateTime lastMod;
                if (!arguments)
                {
                    mod = "Last acces: ";
                    lastMod = System.IO.Directory.GetLastAccessTime(directorys[i]);
                }
                else
                {
                    mod = "Last modify: ";
                    lastMod = System.IO.Directory.GetLastAccessTime(directorys[i]);
                }

                string dir = directorys[i].Replace(CurrentDirectory + @"\", "");
                Console.WriteLine("Directory " + dir + ", " + mod  + lastMod.ToString("dd-MM-yyyy HH:mm:ss"));
            }
            for (int i = 0; i < filesCount; i++)
            {
                string mod;
                DateTime lastMod;

                if (!arguments)
                {
                    mod = "Last acces: ";
                    lastMod = System.IO.File.GetLastAccessTime(files[i]);
                }
                else
                {
                    mod = "Last modify: ";
                    lastMod = System.IO.File.GetLastAccessTime(files[i]);
                }

                string file = files[i].Replace(CurrentDirectory + @"\", "");
                Console.WriteLine(i + 1 + ": " + file + ", " + mod + lastMod.ToString("dd-MM-yyyy HH:mm:ss"));
            }

        }

        void cd(string path = "")
        {
            if (path == "back")
            {
                int amount = CurrentDirectory.Split('\\').Length - 1;
                CurrentDirectory = CurrentDirectory.Replace(@"\" + CurrentDirectory.Split('\\')[amount], "");
                Console.WriteLine("Changed directory to " + CurrentDirectory);
            }
            else if (path != "")
            {
                if (System.IO.Directory.Exists(path))
                {
                    CurrentDirectory = path;
                    Console.WriteLine("Changed directory to " + CurrentDirectory);
                }
                else
                {
                    Console.WriteLine("Directory does not exist.");
                }
            }
            else
            {
                Console.WriteLine("The current directory is: " + CurrentDirectory);
            }
        }

        void throwException(string exceptionToThrow)
        {
            //not only a command, but also a method!
            throw new System.Exception(exceptionToThrow);
        }

        //thanks to Conor
        public void setConsoleSize(string msg, bool arg = false)
        {
            int squareLength;
            if (msg != "max")
            {
                if (!int.TryParse(msg, out squareLength) || int.Parse(msg) < 1 || msg == "")
                {
                    Console.WriteLine("Invalid size, retry?");
                    if (Console.ReadLine().ToLower() == "yes" || Console.ReadLine().ToLower() == "y")
                    {
                        Console.WriteLine("Enter new size:");
                        setConsoleSize(Console.ReadLine().ToLower().Trim());
                    }
                }
                else
                {
                    try
                    {
                        if (arg)
                        {
                            Console.WindowHeight = squareLength;
                        }
                        else
                        {
                            Console.WindowWidth = squareLength;
                        }
                    }
                    catch
                    {
                        Console.WriteLine("An error occured, retry?");
                        if (Console.ReadLine().ToLower() == "yes" || Console.ReadLine() == "y")
                        {
                            Console.WriteLine("Enter new size:");
                            setConsoleSize(Console.ReadLine().ToLower().Trim());
                        }
                    }
                }
            }
            else
            {
                if (arg)
                {
                    Console.WindowHeight = Console.LargestWindowHeight;
                }
                else
                {
                    Console.WindowWidth = Console.LargestWindowWidth;
                }
            }
        }

        void game(string whichGame)
        {
            if (whichGame == "fourinarow")
            {
                _4InARow.RowGame game = new _4InARow.RowGame();
            }
            else
            {
                Console.WriteLine("That game doesn't exist.");
            }
        }
    }
}
